"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("../../../hooks/use-namespace/index.js");
const checkbox = require("./checkbox.js");
const constants = require("./constants.js");
const useCheckbox = require("./composables/use-checkbox.js");
const vue = require("vue");
const _hoisted_1 = [
  "name",
  "tabindex",
  "disabled"
];
var checkbox_button_vue_vue_type_script_setup_true_lang_default = /* @__PURE__ */ vue.defineComponent({
  name: "ElCheckboxButton",
  __name: "checkbox-button",
  props: checkbox.checkboxProps,
  emits: checkbox.checkboxEmits,
  setup(__props) {
    const props = __props;
    const { isFocused, isChecked, isDisabled, checkboxButtonSize, model, actualValue, handleChange } = useCheckbox.useCheckbox(props, vue.useSlots());
    const inputBindings = vue.computed(() => {
      if (props.trueValue || props.falseValue || props.trueLabel || props.falseLabel) return {
        "true-value": props.trueValue ?? props.trueLabel ?? true,
        "false-value": props.falseValue ?? props.falseLabel ?? false
      };
      return { value: actualValue.value };
    });
    const checkboxGroup = vue.inject(constants.checkboxGroupContextKey, void 0);
    const ns = index.useNamespace("checkbox");
    const activeStyle = vue.computed(() => {
      var _a, _b;
      const fillValue = ((_a = checkboxGroup == null ? void 0 : checkboxGroup.fill) == null ? void 0 : _a.value) ?? "";
      return {
        backgroundColor: fillValue,
        borderColor: fillValue,
        color: ((_b = checkboxGroup == null ? void 0 : checkboxGroup.textColor) == null ? void 0 : _b.value) ?? "",
        boxShadow: fillValue ? `-1px 0 0 0 ${fillValue}` : void 0
      };
    });
    const labelKls = vue.computed(() => {
      return [
        ns.b("button"),
        ns.bm("button", checkboxButtonSize.value),
        ns.is("disabled", isDisabled.value),
        ns.is("checked", isChecked.value),
        ns.is("focus", isFocused.value)
      ];
    });
    return (_ctx, _cache) => {
      return vue.openBlock(), vue.createElementBlock("label", { class: vue.normalizeClass(labelKls.value) }, [vue.withDirectives(vue.createElementVNode("input", vue.mergeProps({
        "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => vue.isRef(model) ? model.value = $event : null),
        class: vue.unref(ns).be("button", "original"),
        type: "checkbox",
        name: __props.name,
        tabindex: __props.tabindex,
        disabled: vue.unref(isDisabled)
      }, inputBindings.value, {
        onChange: _cache[1] || (_cache[1] = (...args) => vue.unref(handleChange) && vue.unref(handleChange)(...args)),
        onFocus: _cache[2] || (_cache[2] = ($event) => isFocused.value = true),
        onBlur: _cache[3] || (_cache[3] = ($event) => isFocused.value = false),
        onClick: _cache[4] || (_cache[4] = vue.withModifiers(() => {
        }, ["stop"]))
      }), null, 16, _hoisted_1), [[vue.vModelCheckbox, vue.unref(model)]]), _ctx.$slots.default || __props.label ? (vue.openBlock(), vue.createElementBlock("span", {
        key: 0,
        class: vue.normalizeClass(vue.unref(ns).be("button", "inner")),
        style: vue.normalizeStyle(vue.unref(isChecked) ? activeStyle.value : void 0)
      }, [vue.renderSlot(_ctx.$slots, "default", {}, () => [vue.createTextVNode(vue.toDisplayString(__props.label), 1)])], 6)) : vue.createCommentVNode("v-if", true)], 2);
    };
  }
});
exports.default = checkbox_button_vue_vue_type_script_setup_true_lang_default;
